#include <bits/stdc++.h>
#define maxN 500005

using namespace std;

long long a[maxN],n,i,j,ans,tmp,res;

long long dis(long long x,long long y){
long long tmp=pow(2,y+1),pom=x;
x%=tmp;
tmp/=2;
if(x>=tmp) return 0;
if(tmp-x<x+1 || pom<=x) return tmp-x;
else return -(x+1);
}

int main()
{
    ans=LLONG_MAX;
    cin>>n;
    for(i=0;i<n;i++) cin>>a[i];
    for(j=1;j<32;j++){
        res=0;
        int pom=0;
        for(i=0;i<n;i++){
            tmp=dis(a[i],j);
            res+=abs(tmp);
            //if(j==30) cout<<tmp<<endl;
            pom^=(a[i]+tmp);
        }
        if(pom==0) res++;
        ans=min(ans,res);
    }
    bool b=false;
    int pom=0;
    res=0;
    for(i=0;i<n;i++){
        if(a[i]%2) {pom^=a[i]; continue;}
        res++;
        b=true;
    }
    if(b || pom) ans=min(ans,res);
    else{
        ans=min(ans,res+1);
    }
    cout<<ans<<endl;
    return 0;
}